import { distance } from './utils/math';
export function isPointInPath(displayObject, position) {
  var _displayObject$attrib = displayObject.attributes,
      _displayObject$attrib2 = _displayObject$attrib.r,
      r = _displayObject$attrib2 === void 0 ? 0 : _displayObject$attrib2,
      fill = _displayObject$attrib.fill,
      stroke = _displayObject$attrib.stroke,
      _displayObject$attrib3 = _displayObject$attrib.lineWidth,
      lineWidth = _displayObject$attrib3 === void 0 ? 0 : _displayObject$attrib3;
  var halfLineWidth = lineWidth / 2;
  var absDistance = distance(0, 0, position.x, position.y); // 直接用距离，如果同时存在边和填充时，可以减少两次计算

  if (fill && stroke) {
    return absDistance <= r + halfLineWidth;
  }

  if (fill) {
    return absDistance <= r;
  }

  if (stroke) {
    return absDistance >= r - halfLineWidth && absDistance <= r + halfLineWidth;
  }

  return false;
}
//# sourceMappingURL=Circle.js.map