function ellipseDistance(squareX, squareY, rx, ry) {
  return squareX / (rx * rx) + squareY / (ry * ry);
}

export function isPointInPath(displayObject, _ref) {
  var x = _ref.x,
      y = _ref.y;
  var _displayObject$attrib = displayObject.attributes,
      _displayObject$attrib2 = _displayObject$attrib.rx,
      rx = _displayObject$attrib2 === void 0 ? 0 : _displayObject$attrib2,
      _displayObject$attrib3 = _displayObject$attrib.ry,
      ry = _displayObject$attrib3 === void 0 ? 0 : _displayObject$attrib3,
      fill = _displayObject$attrib.fill,
      stroke = _displayObject$attrib.stroke,
      _displayObject$attrib4 = _displayObject$attrib.lineWidth,
      lineWidth = _displayObject$attrib4 === void 0 ? 0 : _displayObject$attrib4;
  var halfLineWith = lineWidth / 2;
  var squareX = x * x;
  var squareY = y * y; // 使用椭圆的公式： x*x/rx*rx + y*y/ry*ry = 1;

  if (fill && stroke) {
    return ellipseDistance(squareX, squareY, rx + halfLineWith, ry + halfLineWith) <= 1;
  }

  if (fill) {
    return ellipseDistance(squareX, squareY, rx, ry) <= 1;
  }

  if (stroke) {
    return ellipseDistance(squareX, squareY, rx - halfLineWith, ry - halfLineWith) >= 1 && ellipseDistance(squareX, squareY, rx + halfLineWith, ry + halfLineWith) <= 1;
  }

  return false;
}
//# sourceMappingURL=Ellipse.js.map