"use strict";
exports.__esModule = true;
exports.isPointInPath = void 0;
var math_1 = require("./utils/math");
function isPointInPath(displayObject, position) {
    var _a = displayObject.attributes, _b = _a.r, r = _b === void 0 ? 0 : _b, fill = _a.fill, stroke = _a.stroke, _c = _a.lineWidth, lineWidth = _c === void 0 ? 0 : _c;
    var halfLineWidth = lineWidth / 2;
    var absDistance = math_1.distance(0, 0, position.x, position.y);
    // 直接用距离，如果同时存在边和填充时，可以减少两次计算
    if (fill && stroke) {
        return absDistance <= r + halfLineWidth;
    }
    if (fill) {
        return absDistance <= r;
    }
    if (stroke) {
        return absDistance >= r - halfLineWidth && absDistance <= r + halfLineWidth;
    }
    return false;
}
exports.isPointInPath = isPointInPath;
