"use strict";
exports.__esModule = true;
exports.isPointInPath = void 0;
function ellipseDistance(squareX, squareY, rx, ry) {
    return squareX / (rx * rx) + squareY / (ry * ry);
}
function isPointInPath(displayObject, _a) {
    var x = _a.x, y = _a.y;
    var _b = displayObject.attributes, _c = _b.rx, rx = _c === void 0 ? 0 : _c, _d = _b.ry, ry = _d === void 0 ? 0 : _d, fill = _b.fill, stroke = _b.stroke, _e = _b.lineWidth, lineWidth = _e === void 0 ? 0 : _e;
    var halfLineWith = lineWidth / 2;
    var squareX = x * x;
    var squareY = y * y;
    // 使用椭圆的公式： x*x/rx*rx + y*y/ry*ry = 1;
    if (fill && stroke) {
        return ellipseDistance(squareX, squareY, rx + halfLineWith, ry + halfLineWith) <= 1;
    }
    if (fill) {
        return ellipseDistance(squareX, squareY, rx, ry) <= 1;
    }
    if (stroke) {
        return (ellipseDistance(squareX, squareY, rx - halfLineWith, ry - halfLineWith) >= 1 &&
            ellipseDistance(squareX, squareY, rx + halfLineWith, ry + halfLineWith) <= 1);
    }
    return false;
}
exports.isPointInPath = isPointInPath;
