"use strict";
exports.__esModule = true;
exports.containerModule = void 0;
var g_1 = require("@antv/g");
var inversify_1 = require("inversify");
var CanvasPickerPlugin_1 = require("./CanvasPickerPlugin");
var Circle_1 = require("./Circle");
var Ellipse_1 = require("./Ellipse");
var Line_1 = require("./Line");
var Polyline_1 = require("./Polyline");
var Path_1 = require("./Path");
var Rect_1 = require("./Rect");
var Polygon_1 = require("./Polygon");
exports.containerModule = new inversify_1.ContainerModule(function (bind, unbind, isBound, rebind) {
    bind(CanvasPickerPlugin_1.PointInPathPickerFactory).toFactory(function (ctx) { return function (tagName) {
        if (tagName === g_1.SHAPE.Circle) {
            return Circle_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Ellipse) {
            return Ellipse_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Rect) {
            return Rect_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Line) {
            return Line_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Polyline) {
            return Polyline_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Polygon) {
            return Polygon_1.isPointInPath;
        }
        else if (tagName === g_1.SHAPE.Path) {
            return Path_1.isPointInPath;
        }
        return null;
    }; });
    bind(CanvasPickerPlugin_1.CanvasPickerPlugin).toSelf().inSingletonScope();
    bind(g_1.RenderingPluginContribution).toService(CanvasPickerPlugin_1.CanvasPickerPlugin);
});
